<?php

namespace Tell\Reader;

class PhpReader implements ReaderInterface {
    
    protected string $name = "php";
    
    protected array $accept = [ "php" ];
    
    public array $pathList = [];

    public bool $filenameAsKey;
    
    public function __construct(array $pathList, bool $filenameAsKey = false)
    {
        $this->pathList = $pathList;
        $this->filenameAsKey = $filenameAsKey;
    }
    
    public function accept(string $extension) : bool
    {
        return in_array($extension, $this->accept);
    }
    
    public function load(string $filepath) : ?array 
    {
        if ( ! file_exists($filepath) ) {
            throw new \Exception("Given file path is not existing or is inaccessible.");
        }
        
        if ( null === ( $content = include($filepath) ?? false ) ) {
            throw new \Exception("An error occured trying to parse configuration file: given php file [ $filepath ] seems to be invalid");
        }

        return $content;
    }

    public function save(string $filepath, array $content) : bool
    {
        $path = $this->pathList[0];

        if ( ! file_exists($path) ) {
            mkdir($path, '755', true);
        }

        return (bool) file_put_contents($path . DIRECTORY_SEPARATOR . "$filepath." . $this->accept[0], "<?php return " . var_export($content, true) . ";");
    }
}
